/* sf42r.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__42 = 42;

real sf42r_c(real *f, integer *n1, integer *n2, integer *ierr)
{
    /* Initialized data */

    static integer nmax = 20000;
    static real big = 1e13f;
    static integer nmax1 = 20000;
    static real sys015 = .6366198f;
    static real sys059 = 3.4e38f;
    static real sys029 = .7071068f;
    static real sys037 = .3333333f;

    /* System generated locals */
    integer i__1;
    real ret_val, r__1;

    /* Builtin functions */
    double log(doublereal), exp(doublereal), sqrt(doublereal),
            atan(doublereal);

    /* Local variables */
    extern real sf35r_c(real *);
    static real a, b, c__;
    static integer i__;
    static real s, theta;
    extern /* Subroutine */ int utsf12_c(integer *, integer *);
    static real f1, f2;
    static integer i1, i2, l2;
    static real x1, x2, x3, dp, xi, vp, f1f, f2p;
    static integer i2p;
    static real dpl, sts, cbr1, cbr2;

    if (*n1 < 1 || *n2 < 1 || *n1 + *n2 > nmax) {
        goto L20;
    }
    if (*f < 0.f) {
        goto L21;
    }
    *ierr = 0;
    if (*f == 0.f) {
        goto L23;
    }
    f1 = (real) (*n1);
    f2 = (real) (*n2);
    dp = 0.f;
    vp = f1 + f2 - 2.f;
    f1f = f1 * *f;
    f2p = f2 + f1f;
    x1 = f2 / f2p;
    x2 = 1.f - x1;
    if (x2 == 0.f) {
        goto L23;
    }
    if ((*n1 / 2 << 1) - *n1 == 0 && *n1 <= nmax1) {
        goto L1;
    }
    if ((*n2 / 2 << 1) - *n2 == 0 && *n2 <= nmax1) {
        goto L6;
    }
    if (*n1 + *n2 <= nmax1) {
        goto L11;
    }
    f1 = .2222222f / f1;
    f2 = .2222222f / f2;
    cbr1 = sys037 * (real)log(*f);
    cbr1 = (real)exp(cbr1);
    cbr2 = cbr1 * cbr1;
    s = (cbr1 * (1.f - f2) - 1.f + f1) / (real)sqrt((real)(f1 + cbr2 * f2));
    r__1 = -sys029 * s;
    ret_val = (real)sf35r_c(&r__1) * .5f;
    goto L25;
L1:
    if (*n1 == 2) {
        goto L5;
    }
    i1 = *n1 - 2;
    i__1 = i1;
    for (i2 = 2; i2 <= i__1; i2 += 2) {
        l2 = i2;
        i__ = *n1 - i2;
        vp += -2.f;
        dp = x2 * vp / i__ * (dp + 1.f);
        if (dp > big) {
            goto L3;
        }
/* L2: */
    }
    goto L5;
L3:
    if (l2 >= i1) {
        goto L5;
    }
    dpl = (real)log(dp);
    i2p = l2 + 2;
    i__1 = i1;
    for (i2 = i2p; i2 <= i__1; i2 += 2) {
        i__ = *n1 - i2;
        vp += -2.f;
        dpl += (real)log((real)(x2 * vp / i__));
/* L4: */
    }
    x3 = 1.f - (real)exp((real)(f2 * .5f * (real)log(x1) + dpl));
    ret_val = x3;
    goto L19;
L5:
    x2 = (real)exp((real)(f2 * .5f * (real)log(x1)));
    x3 = 1.f - x2 * (dp + 1.f);
    ret_val = x3;
    goto L19;
L6:
    if (*n2 == 2) {
        goto L10;
    }
    i1 = *n2 - 2;
    i__1 = i1;
    for (i2 = 2; i2 <= i__1; i2 += 2) {
        l2 = i2;
        i__ = *n2 - i2;
        vp += -2.f;
        dp = x1 * vp / i__ * (dp + 1.f);
        if (dp > big) {
            goto L8;
        }
/* L7: */
    }
    goto L10;
L8:
    if (l2 >= i1) {
        goto L10;
    }
    dpl = (real)log(dp);
    i2p = l2 + 2;
    i__1 = i1;
    for (i2 = i2p; i2 <= i__1; i2 += 2) {
        i__ = *n2 - i2;
        vp += -2.f;
        dpl += (real)log((real)(x1 * vp / i__));
/* L9: */
    }
    x3 = (real)exp((real)(f1 * .5f * (real)log(x2) + dpl));
    ret_val = x3;
    goto L19;
L10:
    x2 = (real)exp((real)(f1 * .5f * (real)log(x2)));
    x3 = x2 * (dp + 1.f);
    ret_val = x3;
    goto L19;
L11:
    dp = (real)sqrt((real)(f1f / f2));
    theta = (real)atan(dp);
    sts = f1f / f2p;
    a = 0.f;
    b = 0.f;
    if (*n2 == 1) {
        goto L14;
    }
    if (*n2 == 3) {
        goto L13;
    }
    i1 = *n2 - 3;
    i__1 = i1;
    for (i2 = 2; i2 <= i__1; i2 += 2) {
        xi = f2 - i2;
        a = x1 * (xi - 1.f) / xi * (a + 1.f);
/* L12: */
    }
L13:
    a = x1 * dp * (a + 1.f);
L14:
    a += theta;
    if (*n1 == 1) {
        goto L18;
    }
    if (*n1 == 3) {
        goto L16;
    }
    i1 = *n1 - 3;
    i__1 = i1;
    for (i2 = 2; i2 <= i__1; i2 += 2) {
        xi = f1 - i2;
        vp += -2.f;
        b = sts * vp / xi * (b + 1.f);
/* L15: */
    }
L16:
    b = dp * x1 * (b + 1.f);
    if (*n2 == 1) {
        goto L18;
    }
    i2 = *n2 / 2;
    c__ = 1.f;
    i__1 = i2;
    for (i__ = 1; i__ <= i__1; ++i__) {
        b = b * x1 * c__ / (c__ - .5f);
        c__ += 1.f;
/* L17: */
    }
L18:
    x3 = sys015 * (a - b);
    ret_val = x3;
L19:
    if (x3 < 0.f) {
        ret_val = 0.f;
    }
    goto L25;
L20:
    *ierr = 65;
    goto L22;
L21:
    *ierr = 66;
L22:
    ret_val = sys059;
    goto L24;
L23:
    ret_val = 0.f;
    goto L25;
L24:
    utsf12_c(ierr, &c__42);
L25:
    return ret_val;
} /* sf42r_c */
